#!/usr/bin/env python3

from ctypes import Structure, addressof, create_string_buffer, c_uint64, c_uint32, c_uint16, c_uint8

import os
import fcntl
import struct
import time


SPI_MODE = 0
SPI_SPEED_HZ = 500000
SPI_BITS_PER_WORD = 8


SPI_IOC_RD_MODE = 0x80016b01
SPI_IOC_WR_MODE = 0x40016b01
SPI_IOC_RD_MODE32 = 0x80046b05
SPI_IOC_WR_MODE32 = 0x40046b05
SPI_IOC_RD_LSB_FIRST = 0x80016b02
SPI_IOC_WR_LSB_FIRST = 0x40016b02
SPI_IOC_RD_BITS_PER_WORD = 0x80016b03
SPI_IOC_WR_BITS_PER_WORD = 0x40016b03
SPI_IOC_RD_MAX_SPEED_HZ = 0x80046b04
SPI_IOC_WR_MAX_SPEED_HZ = 0x40046b04
SPI_IOC_MESSAGE_1 = 0x40206b00


class spi_ioc_transfer(Structure):
    _fields_ = [
        ("tx_buf", c_uint64),
        ("rx_buf", c_uint64),
        ("len", c_uint32),
        ("speed_hz", c_uint32),
        ("delay_usecs", c_uint16),
        ("bits_per_word", c_uint8),
        ("cs_change", c_uint8),
        ("pad", c_uint32)]


def spi_transfer(fd, tx_data):
    tx_buffer = create_string_buffer(bytes(tx_data))
    rx_buffer = create_string_buffer(len(tx_data))

    xfer = spi_ioc_transfer(
            tx_buf=addressof(tx_buffer),
            rx_buf=addressof(rx_buffer),
            len=len(tx_data),
            delay_usecs=0,
            speed_hz=SPI_SPEED_HZ,
            bits_per_word=SPI_BITS_PER_WORD,
            cs_change = 0,
            )

    fcntl.ioctl(fd, SPI_IOC_MESSAGE_1, xfer)

    return list(rx_buffer)


def MAX7219_write(fd, address1, dat1, address2, dat2):
    spi_transfer(fd, [address1])
    spi_transfer(fd, [dat1])
    spi_transfer(fd, [address2])
    spi_transfer(fd, [dat2])


def MAX7219_init(fd):
    MAX7219_write(fd, 0x09, 0x00, 0x09, 0x00)
    MAX7219_write(fd, 0x0a, 0x03, 0x0a, 0x03)
    MAX7219_write(fd, 0x0b, 0x07, 0x0b, 0x07)
    MAX7219_write(fd, 0x0c, 0x01, 0x0c, 0x01)
    MAX7219_write(fd, 0x0f, 0x00, 0x0f, 0x00)


CODE = [
        [0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x3C],  #0
        [0x10,0x30,0x50,0x10,0x10,0x10,0x10,0x7C],  #1
        [0x3E,0x02,0x02,0x3E,0x20,0x20,0x3E,0x00],  #2
        [0x00,0x7C,0x04,0x04,0x7C,0x04,0x04,0x7C],  #3
        [0x08,0x18,0x28,0x48,0xFE,0x08,0x08,0x08],  #4
        [0x3C,0x20,0x20,0x3C,0x04,0x04,0x3C,0x00],  #5
        [0x3C,0x20,0x20,0x3C,0x24,0x24,0x3C,0x00],  #6
        [0x3E,0x22,0x04,0x08,0x08,0x08,0x08,0x08],  #7
        [0x00,0x3E,0x22,0x22,0x3E,0x22,0x22,0x3E],  #8
        [0x3E,0x22,0x22,0x3E,0x02,0x02,0x02,0x3E],  #9
        [0x08,0x14,0x22,0x3E,0x22,0x22,0x22,0x22],  #A
        [0x3C,0x22,0x22,0x3E,0x22,0x22,0x3C,0x00],  #B
        [0x3C,0x40,0x40,0x40,0x40,0x40,0x3C,0x00],  #C
        [0x7C,0x42,0x42,0x42,0x42,0x42,0x7C,0x00],  #D
        [0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x7C],  #E
        [0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x40],  #F
        [0x3C,0x40,0x40,0x40,0x40,0x44,0x44,0x3C],  #G
        [0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44],  #H
        [0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x7C],  #I
        [0x3C,0x08,0x08,0x08,0x08,0x08,0x48,0x30],  #J
        [0x00,0x24,0x28,0x30,0x20,0x30,0x28,0x24],  #K
        [0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C],  #L
        [0x81,0xC3,0xA5,0x99,0x81,0x81,0x81,0x81],  #M
        [0x00,0x42,0x62,0x52,0x4A,0x46,0x42,0x00],  #N
        [0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x3C],  #O
        [0x3C,0x22,0x22,0x22,0x3C,0x20,0x20,0x20],  #P
        [0x1C,0x22,0x22,0x22,0x22,0x26,0x22,0x1D],  #Q
        [0x3C,0x22,0x22,0x22,0x3C,0x24,0x22,0x21],  #R
        [0x00,0x1E,0x20,0x20,0x3E,0x02,0x02,0x3C],  #S
        [0x00,0x3E,0x08,0x08,0x08,0x08,0x08,0x08],  #T
        [0x42,0x42,0x42,0x42,0x42,0x42,0x22,0x1C],  #U
        [0x42,0x42,0x42,0x42,0x42,0x42,0x24,0x18],  #V
        [0x00,0x49,0x49,0x49,0x49,0x2A,0x1C,0x00],  #W
        [0x00,0x41,0x22,0x14,0x08,0x14,0x22,0x41],  #X
        [0x41,0x22,0x14,0x08,0x08,0x08,0x08,0x08],  #Y
        [0x00,0x7F,0x02,0x04,0x08,0x10,0x20,0x7F],  #Z
        ]


def main():
    print('*'*50)
    fd = os.open('/dev/spidev0.0', os.O_RDWR)

    fcntl.ioctl(fd, SPI_IOC_RD_BITS_PER_WORD, bytes([SPI_BITS_PER_WORD]))
    fcntl.ioctl(fd, SPI_IOC_WR_BITS_PER_WORD, bytes([SPI_BITS_PER_WORD]))

    fcntl.ioctl(fd, SPI_IOC_WR_MODE, bytes([SPI_MODE]))
    fcntl.ioctl(fd, SPI_IOC_WR_MAX_SPEED_HZ, SPI_SPEED_HZ.to_bytes(4, byteorder='little'))

    MAX7219_init(fd)

    try:
        for j in range(37):
            for i in range(1, 9):
                print(i, j, CODE[j+1][i-1], CODE[j][i-1])
                MAX7219_write(fd, i, CODE[j+1][i-1], i, CODE[j][i-1]);
                time.sleep(.1)
    except KeyboardInterrupt:
        os.close(fd)

if __name__ == "__main__":
    main()